#One way of doing it correctly

#Example method to clean path of directory traversal sequences.
#Notes: Cannot simply reject names with directory traversal sequences
#in them; after all, ..\..\name is a valid filename on Linux, and 
#Metasploit must be able to transfer files between OS without failure.
#Must accept path/with/..a/folder../starting/or/ending/in/two/dots
#but clean ../starting/traversal as well as path/with/..\inner/traversal
#Single pass replacement doesn't work; it turns blah/./.././blah into
#blah/../blah, so loop until no directory traversal sequences exist.
def clean_path (oldPath)
    path = oldPath
    while(path.index(/\/..\/|\/..\\|\\..\\|\\..\/|\A..\\|\A..\//) != nil)
        path.gsub!(/\A..\\|\A..\//,'') #eliminate starting ..\ or ../
        path.gsub!(/\/..\/|\/..\\/,'/') #clean linux style
        path.gsub!(/\\..\\|\\..\//,'\\') #clean windows style
    end
	path
end
